extern odinmp_team_t odinmp_main_team;
extern odinmp_shared_data_t odinmp_shared_data;
extern odinmp_thread_data_t **odinmp_thread_datas;
extern int odinmp_num_threads;
extern int odinmp_num_threads_allocated;
extern int odinmp_debug;
extern int odinmp_timing;
extern pthread_key_t odinmp_pthread_key;
extern pthread_mutex_t odinmp_atomic_lock;
extern odinmp_scheduler_t odinmp_runtime_scheduler;

#ifdef ODINMP_TIMING
extern double odinmp_timer_global_preStartTime;
extern double odinmp_timer_global_startTime;
extern double odinmp_timer_global_stopTime;

extern odinmp_tacc_t odinmp_wait_finished_tacc;
#endif /* ODINMP_TIMING */

extern void odinmp_printf(char *fmt, ...);
extern void odinmp_thread(odinmp_thread_data_t *odinmp_td);
extern void odinmp_thread_init(odinmp_thread_data_t *td, int i);
extern odinmp_thread_data_t *odinmp_self_data();
extern void odinmp_start_thread();
extern void odinmp_stop_thread(odinmp_thread_data_t *td);
extern int odinmp_get_num_threads(void);
extern void odinmp_set_num_threads(int num_threads);
extern odinmp_thread_data_t *odinmp_allocate_thread_data();
extern odinmp_team_t *odinmp_allocate_team(int max_num_threads);
extern int odinmp_get_thread_num();
extern int odinmp_is_master();
extern void odinmp_dispatch(odinmp_thread_data_t *td);
extern void odinmp_free_team(odinmp_team_t *team);
extern void odinmp_wait_for_work(odinmp_thread_data_t *td);
extern void odinmp_finished_work(odinmp_thread_data_t *td);
extern void odinmp_wait_finished(odinmp_thread_data_t *td);
extern void odinmp_thread_spin(odinmp_thread_data_t *td);
extern void *odinmp_thread_pthread(void *data);
extern void odinmp_init ();
extern void odinmp_atexit();
extern void odinmp_complain();
extern int odinmp_get_num_procs();
extern void odinmp_barrier(odinmp_team_t *team, odinmp_barrier_t *b);
extern void odinmp_sync_memory();
extern double odinmp_time();
extern void odinmp_tacc_init(odinmp_tacc_t *tacc);
extern void odinmp_tacc_add(odinmp_tacc_t *tacc, double d);
extern void odinmp_parse_env ();
extern void odinmp_parse_args (int *argc, char **argv);
