#ifndef __OMP_H__
#define __OMP_H__

#include <pthread.h>

extern void omp_set_num_threads(int num_threads);
extern int omp_get_num_threads(void);

extern int omp_get_max_threads();

extern int omp_get_thread_num();

extern int omp_get_num_procs();

extern int omp_in_parallel();

extern void omp_set_dynamic(int dymanic_threads);
extern int omp_get_dynamic();

extern void omp_set_nested(int nested);
extern int omp_get_nested();

/* lock stuff */
typedef pthread_mutex_t omp_lock_t;
typedef struct {
  pthread_mutex_t mutex;
  pthread_cond_t released;
  pthread_t locked_by;
  int depth;
} omp_nest_lock_t;

extern void omp_init_lock(omp_lock_t *lock);
extern void omp_init_nest_lock(omp_nest_lock_t *lock);

extern void omp_destroy_lock(omp_lock_t *lock);
extern void omp_destroy_nest_lock(omp_nest_lock_t *lock);

extern void omp_set_lock(omp_lock_t *lock);
extern void omp_set_nest_lock(omp_nest_lock_t *lock);

extern void omp_unset_lock(omp_lock_t *lock);
extern void omp_unset_nest_lock(omp_nest_lock_t *lock);

extern int omp_test_lock(omp_lock_t *lock);
extern int omp_test_nest_lock(omp_nest_lock_t *lock);

#endif /* __OMP_H__ */
