#include <stdio.h>
#include <sys/time.h>

#define N 100000000

main() {
  double local, pi=0.0, w;
  struct timeval start_time, end_time;
  double exe_time;
  long i;

  w = 1.0 / N;

  gettimeofday(&start_time, 0);

#pragma omp parallel private(i, local) 
  {
#pragma omp single
    pi = 0.0;
#pragma omp for reduction (+: pi)
    for (i = 0; i < N; i++) {
      local = (i + 0.5)*w;
      pi = pi + 4.0/(1.0 + local*local);
    }
  }

  gettimeofday(&end_time, 0);
  exe_time = end_time.tv_sec - start_time.tv_sec;
  exe_time = exe_time + (end_time.tv_usec - start_time.tv_usec) / 1e6;

  printf("pi is %1.20f\n", pi*w);
  printf("It took %f seconds\n", exe_time);
}
